#include <Stepper_28BYJ.h>
#include <EEPROM.h>
#define STEPS 4078

const int sensorPin = A0;
int wot = 9;

int ledl1 = 4;
int ledl2 = 3;
int ledl3 = 2;
int ledl4 = 1;

int ledr1 = A3;
int ledr2 = A4;
int ledr3 = A5;
int ledr4 = 0;

int btnl = A2;
int btnr = A1;

int tpause = 0;
int tspeed = 0;
int mpause = 0;
int mspeed = 0;

Stepper_28BYJ stepper(STEPS, 5, 6, 7, 8);
int val = 100;

void setup() {    
  delay(500);  
  pinMode(ledl1, OUTPUT);  
  pinMode(ledl2, OUTPUT);
  pinMode(ledl3, OUTPUT);
  pinMode(ledl4, OUTPUT);
  
  pinMode(ledr1, OUTPUT);
  pinMode(ledr2, OUTPUT);
  pinMode(ledr3, OUTPUT);
  pinMode(ledr4, OUTPUT);

  pinMode(wot, OUTPUT);  
  
  //stepper.setSpeed(12);
  
  mpause = EEPROM.read(1);
  mspeed = EEPROM.read(2);
}

void loop() {
   
  int btnlState = digitalRead(btnl); 
  int btnrState = digitalRead(btnr);
  int sensorState = digitalRead(sensorPin);
  
  if (btnlState == LOW) 
    {
    mpause++;
    if(mpause>4){mpause=1;}    
    EEPROM.write(1, mpause);
    delay(500);
    }
    
  if (btnrState == LOW) 
    {
    mspeed++;
    if(mspeed>4){mspeed=1;}
    EEPROM.write(2, mspeed);    
    delay(500);
    }
     
  if(mpause==1){digitalWrite(ledl1, HIGH);digitalWrite(ledl2, LOW);digitalWrite(ledl3, LOW);digitalWrite(ledl4, LOW);}
  if(mpause==2){digitalWrite(ledl1, HIGH);digitalWrite(ledl2, HIGH);digitalWrite(ledl3, LOW);digitalWrite(ledl4, LOW);}
  if(mpause==3){digitalWrite(ledl1, HIGH);digitalWrite(ledl2, HIGH);digitalWrite(ledl3, HIGH);digitalWrite(ledl4, LOW);}
  if(mpause==4){digitalWrite(ledl1, HIGH);digitalWrite(ledl2, HIGH);digitalWrite(ledl3, HIGH);digitalWrite(ledl4, HIGH);}  
     
  if(mspeed==1){digitalWrite(ledr1, HIGH);digitalWrite(ledr2, LOW);digitalWrite(ledr3, LOW);digitalWrite(ledr4, LOW);}
  if(mspeed==2){digitalWrite(ledr1, HIGH);digitalWrite(ledr2, HIGH);digitalWrite(ledr3, LOW);digitalWrite(ledr4, LOW);}
  if(mspeed==3){digitalWrite(ledr1, HIGH);digitalWrite(ledr2, HIGH);digitalWrite(ledr3, HIGH);digitalWrite(ledr4, LOW);}
  if(mspeed==4){digitalWrite(ledr1, HIGH);digitalWrite(ledr2, HIGH);digitalWrite(ledr3, HIGH);digitalWrite(ledr4, HIGH);}
  
  if (sensorState == HIGH) 
    {
    digitalWrite(wot, HIGH);
    delay(tpause);
    tspeed = mspeed*2;
    tpause = mpause*250; 
    stepper.setSpeed(tspeed);
    while(digitalRead(sensorPin) == HIGH){stepper.step(val);}
    //stepper.step(tspeed);  
    }
  else
    {
    digitalWrite(5, LOW);  
    digitalWrite(6, LOW); 
    digitalWrite(7, LOW); 
    digitalWrite(8, LOW); 
    digitalWrite(wot, LOW);    // turn the LED off by making the voltage LOW  
    }
  
}
